/*
** Copyright (c) 2000 by Software Daten Service GesmbH
** Handelskai 94-96, 1200 Vienna,  AUSTRIA
**
** THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
** NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
** OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
** CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
** REDISTRIBUTION OF THIS SOFTWARE.
*/

package junit.extensions;

import java.util.StringTokenizer;

/**
* Class for holding the command line arguments using the system properties
* using the key "junit.argv"
*
* @author  Siegfried GOESCHL
* @version $Id: RepositoryImpl.java,v 1.1.1.1 1999/04/23 11:43:22 wdsgoe Exp $
*/

public class Argv
{
    static private String[] argv = null;

    static public synchronized String[] getArgv() {

        if( argv == null ) {

            String arg = System.getProperty( "junit.argv" );

            if( arg == null ) {
                argv = new String[0];
            }
            else {
                int idx = 0;
                StringTokenizer tokenizer =
                                   new StringTokenizer( arg, " \t|" );

                argv = new String[ tokenizer.countTokens() ];

                while( tokenizer.hasMoreTokens() ) {
                    argv[idx++] = tokenizer.nextToken();
                }
            }
        }

        return argv;
    }

    static public synchronized void setArgv( String[] newValue ) {

        if( argv == null ) {
            argv = newValue;
        }
    }


    static public String print() {
        StringBuffer result = new StringBuffer();
        for( int i=0; i<getArgv().length; i++ ) {
            result.append( getArgv()[i] );
            result.append( ' ' );
        }
        return result.toString();
    }
}


