/*
** Copyright (c) 2000 by Software Daten Service GesmbH
** Handelskai 94-96, 1200 Vienna,  AUSTRIA
**
** THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
** NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
** OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
** CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
** REDISTRIBUTION OF THIS SOFTWARE.
*/

package junit.extensions;

import junit.framework.Test;

/**
 * Interface for accessing test data
 *
 * @author  Siegfried GOESCHL
 * @version $Id: RepositoryImpl.java,v 1.1.1.1 1999/04/23 11:43:22 wdsgoe Exp $
 */

public interface ConfigurableTest extends Test {

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    boolean getBoolean( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    char getChar( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    byte getByte( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    short getShort( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    int getInteger( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    long getLong( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    String getString( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    float getFloat( String key ) throws IllegalArgumentException;

    /**
     * Retrieve a value from the test data repository
     *
     * @param key key
     * @return value
     * @exception IllegalArgumentException key not found
     */

    double getDouble( String key ) throws IllegalArgumentException;
}