/*
** Copyright (c) 2000 by Software Daten Service GesmbH
** Handelskai 94-96, 1200 Vienna,  AUSTRIA
**
** THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
** NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
** OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
** CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
** REDISTRIBUTION OF THIS SOFTWARE.
*/

package junit.properties;

import junit.framework.TestCase;

/**
* Interface for test data containers
*
* @author  Siegfried GOESCHL
* @version $Id: RepositoryImpl.java,v 1.1.1.1 1999/04/23 11:43:22 wdsgoe Exp $
*/

public interface TestProperties
{
    boolean getBoolean( Object obj, String function, String key )
        throws IllegalArgumentException;

    char getChar( Object obj, String function, String key )
        throws IllegalArgumentException;

    byte getByte( Object obj, String function, String key )
        throws IllegalArgumentException;

    short getShort( Object obj, String function, String key )
        throws IllegalArgumentException;

    int getInteger( Object obj, String function, String key )
        throws IllegalArgumentException;

    long getLong( Object obj, String function, String key )
        throws IllegalArgumentException;

    String getString( Object obj, String function, String key )
        throws IllegalArgumentException;

    float getFloat( Object obj, String function, String key )
        throws IllegalArgumentException;

    double getDouble( Object obj, String function, String key )
        throws IllegalArgumentException;

}


