/*
** Copyright (c) 2000 by Software Daten Service GesmbH
** Handelskai 94-96, 1200 Vienna,  AUSTRIA
**
** THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
** NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
** OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
** CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
** REDISTRIBUTION OF THIS SOFTWARE.
*/

package junit.tests.extensions;

import junit.framework.*;
import junit.extensions.*;

/**
 * TestSuite that runs all the sample tests
 *
 * @author  Siegfried GOESCHL
 * @version $Id: RepositoryImpl.java,v 1.1.1.1 1999/04/23 11:43:22 wdsgoe Exp $
 */

public class AllTests extends ConfigurableTestCase{

    public AllTests( String name ) {
        super(name);
    }

    public static void main (String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    public static Test suite ( ) {

        // load property file for AllTests

        initTestProperties( AllTests.class );

        TestSuite suite= new TestSuite("Framework Extensions Test");

        suite.addTest(new TestSuite(ConfigurableTestCaseTest.class));
        suite.addTest(ConfigurableTestSetupTest.suite());
        suite.addTest(ArgvTest.suite());

        // run all other tests too ... :-)

        // suite.addTest(junit.tests.AllTests.suite());

        return suite;
    }
}