/*
** Copyright (c) 2000 by Software Daten Service GesmbH
** Handelskai 94-96, 1200 Vienna,  AUSTRIA
**
** THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
** NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
** OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
** CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
** REDISTRIBUTION OF THIS SOFTWARE.
*/

package junit.tests.extensions;

/**
 * @author  Siegfried GOESCHL
 * @version $Id: RepositoryImpl.java,v 1.1.1.1 1999/04/23 11:43:22 wdsgoe Exp $
 */

import junit.framework.*;
import junit.extensions.*;

public class ConfigurableTestSetupTest extends ConfigurableTestCase {

    public ConfigurableTestSetupTest( String name ) {
        super(name);
    }

    public static void main(String args[]) {
        junit.textui.TestRunner.run( ConfigurableTestSetupTest.suite() );
    }

    public static Test suite() {

        // load property file for ConfigurableTestCaseSetup

        initTestProperties( ConfigurableTestSetupTest.class );

        TestSuite suite= new TestSuite();

        suite.addTest( ConfigurableTestCaseTest.suite() );

        // instantiate inner class with name 'ConfigurableTestSetupTest$1'

        ConfigurableTestSetup wrapper= new ConfigurableTestSetup(suite) {
            private boolean isSetup = false;
            private boolean isConfigFileAvailable = false;
            public void setUp() {
                isSetup = true;
                isConfigFileAvailable = getBoolean( "isConfigFileAvailable" );
            }
            public void tearDown() {
                Assert.assert( "setup() had to be invoked", isSetup );
                Assert.assert( "expect TRUE from config file", isConfigFileAvailable );
            }
        };

        return wrapper;
   }
}