
//Title:      Test Application for NetworkClassLoader
//Version:    
//Copyright:  Copyright (c) 1998
//Author:     Lorenzo Bettini, Donato Cappetta
//Company:    
//Description:A Test Application for NetworkClassLoader
package loaderapp;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;

public class AppFrame extends JFrame {

  //Construct the frame
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JToolBar toolBar = new JToolBar();
  JButton openButton = new JButton();
  JButton saveButton = new JButton();
  JButton helpButton = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JLabel statusBar = new JLabel();
  JMenuItem menuFileOpen = new JMenuItem();
  JMenuItem menuFileSave = new JMenuItem();
  JMenuItem menuFileSaveAs = new JMenuItem();
  JMenuItem menuHelpAboutAuthors = new JMenuItem();
  JMenuItem menuFileMusic = new JMenuItem();
  JPanel textPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JTextArea text_area = new JTextArea();
  
  public AppFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
      openButton.setIcon(image1);
      saveButton.setIcon(image2);
      helpButton.setIcon(image3);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
//Component initialization

  private void jbInit() throws Exception  {
    image1 = new ImageIcon(getClass().getResource("openFile.gif"));
    image2 = new ImageIcon(getClass().getResource("saveFile.gif"));
    image3 = new ImageIcon(getClass().getResource("help.gif"));
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Frame Title");
    statusBar.setText(" ");
    menuFileOpen.setText("Open");
    menuFileOpen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuFileOpen_actionPerformed(e);
      }
    });
    menuFileSave.setText("Save");
    menuFileSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuFileSave_actionPerformed(e);
      }
    });
    menuFileSaveAs.setText("Save as");
    menuFileSaveAs.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuFileSaveAs_actionPerformed(e);
      }
    });
    menuHelpAboutAuthors.setText("About Authors");
    menuHelpAboutAuthors.setText("About the Authors");
    menuHelpAboutAuthors.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuHelpAboutAuthors_actionPerformed(e);
      }
    });
    menuFileMusic.setText("Music");
    textPanel.setLayout(borderLayout2);
    menuFileMusic.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuFileMusic_actionPerformed(e);
      }
    });
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    openButton.setToolTipText("Open File");
    openButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        openButton_actionPerformed(e);
      }
    });
    saveButton.setToolTipText("Save File");
    saveButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saveButton_actionPerformed(e);
      }
    });
    helpButton.setToolTipText("Help");
    helpButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        helpButton_actionPerformed(e);
      }
    });
    toolBar.add(openButton);
    toolBar.add(saveButton);
    toolBar.add(helpButton);
    menuFile.add(menuFileOpen);
    menuFile.add(menuFileSave);
    menuFile.add(menuFileSaveAs);
    menuFile.addSeparator();
    menuFile.add(menuFileMusic);
    menuFile.addSeparator();
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuHelp.add(menuHelpAboutAuthors);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
    this.getContentPane().add(statusBar, BorderLayout.SOUTH);
    this.getContentPane().add(textPanel, BorderLayout.CENTER);
    textPanel.add(text_area, BorderLayout.CENTER);
  }
//File | Exit action performed

  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
//Help | About action performed

  public void helpAbout_actionPerformed(ActionEvent e) {
    aboutBox();
  }

  protected void aboutBox()
  {
    AppFrame_AboutBox dlg = new AppFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(false);
    dlg.show();
  }
//Overriden so we can exit on System Close

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void menuFileOpen_actionPerformed(ActionEvent e) {
    openFile();
  }

  protected void openFile()
  {
    FileDialog file_dialog = new FileDialog (this, "Load a file");
    file_dialog.show ();
    String directory = file_dialog.getDirectory ();
    String file = file_dialog.getFile ();

    if (file.length () > 0)
      text_area.append ("You chose " + directory + file + "\n");
  }

  void menuFileSave_actionPerformed(ActionEvent e) {
    saveFile();
  }

  protected void saveFile()
  {
    NotImplementedDialog dlg =
      new NotImplementedDialog(this, "Sorry", true);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  void menuFileSaveAs_actionPerformed(ActionEvent e) {
    saveFileAs();
  }

  protected void saveFileAs()
  {
    FileDialog file_dialog = new FileDialog
      (this, "Save as", FileDialog.SAVE);
    file_dialog.show ();

    saveFile();
  }

  void menuFileMusic_actionPerformed(ActionEvent e) {
    PlayMusic();
  }

  protected void PlayMusic()
  {
    text_area.append("Let's play some music :-)\n");
    AudioClip audioClip = 
      Applet.newAudioClip(getClass().getResource("spacemusic.au"));
    audioClip.play();
  }

  void menuHelpAboutAuthors_actionPerformed(ActionEvent e) {
    about_authors();
  }

  protected void about_authors()
  {
    AuthorsFrame dlg = new AuthorsFrame();
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.show();
  }

  void openButton_actionPerformed(ActionEvent e) {
    openFile();
  }

  void saveButton_actionPerformed(ActionEvent e) {
    saveFile();
  }

  void helpButton_actionPerformed(ActionEvent e) {
    aboutBox();
  }
}


